"""Sub-package startup sequencing."""

from __future__ import absolute_import

import os, sys, logging, pdb

from RASconfig import Globals

# Do NOT put something in here you don't want globally exposed.
# I used to read the subdirs, but that seemed a little too forgiving.

__all__ = [ "IPMIlogs" ]

# Process is still PWD one level up so qualify the names.

def setup():
    """Called only from main.  This package should NOT be called first."""
    for subpkg in __all__:
        try:
            # exec "from %s import *" % subpkg
            __import__(subpkg, globals(), locals(), [ ], 1)
        except (SyntaxError, ImportError, ValueError):
            continue

        subpkgfqdn = "%s.%s" % (__name__, subpkg)
        subpkg = sys.modules[subpkgfqdn]
        if not hasattr(subpkg, "__all__"):
            logging.critical("%s DOES NOT HAVE __all__", subpkgfqdn)
            print >> sys.stderr, "%s DOES NOT HAVE __all__" % subpkgfqdn
            return False
        for modname in subpkg.__all__:
            thisfqdn = "%s.%s" % (subpkgfqdn, modname)
            __import__(thisfqdn, globals(), locals(), [ ], -1)
            thismod = sys.modules[thisfqdn]
            if hasattr(thismod, "Setup"):
                logging.warning("Running %s.Setup()", thisfqdn)
                thismod.Setup()

    if (Globals.opts.verbose > 3):	# Yes, it takes 4
        logging.debug("HP modules @ %s:" % __name__)
        logging.debug(sorted(
	        k for k, v in sys.modules.iteritems() if hasattr(v, "HP")))
    return True
