"""Sub-package startup sequencing."""

from __future__ import absolute_import	# Forces python 2.5

import pdb
import logging
import sys

# Do NOT put something in here you don't want globally exposed.
# "daemonize" is the best example.   EventManager MUST be first, as
# it sets up things needed by HPDBus.  Also, every member of __all__
# needs a global setup().

__all__ = [ "EventManager", "DBus" ]

# Process is still PWD one level up so qualify the names.

def setup():
    """Called only from main.  This package MUST be called first."""
    for subpkg in __all__:
        try:
            __import__(subpkg, globals(), locals(), [ ], 1)
        except (SyntaxError, ImportError, ValueError):
            logging.critical("%s failed to import", subpkg)
            return False
        fqsubpkg = "%s.%s" % (__name__, subpkg)
        thismod = sys.modules[fqsubpkg]
        logging.warning("Running %s.setup()", fqsubpkg)
        if not thismod.setup():
            return False
    return True
